// RenditionTest.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include "verite.h"
#include "Redline.h"

using namespace std;

HWND GetWindowHandle()
{
#define MY_BUFSIZE 1024 // Buffer size for console window titles.
    //HWND hwndFound{};         // This is what is returned to the caller.
    //char pszNewWindowTitle[MY_BUFSIZE]; // Contains fabricated
    // WindowTitle.
    char pszOldWindowTitle[MY_BUFSIZE] = "RRedline Test";// Contains original
    // WindowTitle.

// Fetch current window title.

    GetConsoleTitleA(pszOldWindowTitle, MY_BUFSIZE);

    //SetConsoleTitleA(pszNewWindowTitle);

    Sleep(40);

    // Look for NewWindowTitle.

    return FindWindowA(NULL, pszOldWindowTitle);

}

int main()
{


    HWND hwnd = GetWindowHandle();

    if (!hwnd)
        cout << "Error: Could not get Window handle" << endl;
   


    //std::cout << "Hello World!\n";
    v_verite_info info;
    v_u32 counter=1;
	cout << "info address = "  << hex << (size_t)&info << dec << " size " << sizeof(info) << endl;
    while (V_SUCCESS == V_EnumVeriteBoards(hwnd, counter, &info))
    {
		cout << "****************************************" << endl;
        cout << "Board #\t" << dec << counter++ << endl;;
        cout << "Verite ID\t0x" << hex << info.veriteID << endl;
        
        cout << "MemBase\t0x" << info.memBase << endl;
		cout << "memSize\t" << dec << info.memSize << endl;
		cout << "IoBase\t0x" << hex << info.ioBase << endl;
        cout << "MemMappedIoBase\t0x" << info.memMappedIoBase << endl;
        //cout << "IOBase\t0x" << hex << info.ioBase << endl;
        cout << "BusMaster\t0x" << (size_t) info.busMaster << endl;
        cout << "VGA Device\t0x" << (size_t)info.vgaDevice << endl;
		cout << "****************************************" << endl;


		//unsigned char* io = (unsigned char *)&info;//(info.memMappedIoBase);
		//for(int i = 0; i < sizeof(info); i++)
		//	cout << "Port " << dec << i << " value " << hex << (size_t)*(io+i)  << dec << endl;


		cout << endl;
    }
	cout << "Press [ENTER] to close" << endl;
	cin.get();
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
